if Fence:HasModule('SinglePrice') then return end

local L = AceLibrary("AceLocale-2.2"):new("Fence_SinglePrice")
local l = AceLibrary("AceLocale-2.2"):new("Fence")
local abc = AceLibrary("Abacus-2.0")

-- Localization
L:RegisterTranslations("enUS", function() return {
		["Single Price"] = true,
		["Show Bid"] = true,
		["Text Style"] = true,
		["Change single price style."] = true,
		["Bid"] = true,
        ["Change bid style."] = true,
        ["Bid Style"] = true,
	}
end)

L:RegisterTranslations("deDE", function() return {
		["Single Price"] = "Single Price",
		["Show Bid"] = "Gebotanzeige",
		["Text Style"] = "Einzelpreisstil",
		["Change single price style."] = "Stil f\195\188r Einzelpreis anpassen.",
		["Bid"] = "Gebot",
        ["Change bid style."] = "Stil f\195\188r Gebote anpassen.",
        ["Bid Style"] = "Gebotstil"
	}
end)

local mod = Fence:NewModule("SinglePrice")
	
	function mod:OnInitialize()
		self.db = Fence:AcquireDBNamespace("SinglePrice")
		if self.db.profile.showBid == nil then self.db.profile.showBid = true end
		if self.db.profile.style == nil then self.db.profile.style = "short" end
        if self.db.profile.bidStyle == nil then self.db.profile.bidStyle = "fade" end


		
		Fence.options.args.singleprice = {
			type = 'group',
			name = L["Single Price"], aliases='sp',
			desc = string.format(l["%s options"], L["Single Price"]),
				args = {
					toggle = {
						type = 'toggle',
						name = L["Single Price"],
						desc = string.format(l["Toggles %s function."], L["Single Price"]),
						get = function() return Fence:IsModuleActive("SinglePrice") end,
						set = function(v) Fence:ToggleModuleActive("SinglePrice", v) end
					},
					textstyle= {
						type = 'text',
						name = L["Text Style"], 
						desc = L["Change single price style."],
						get = function() return self.db.profile.style end,
						set = function(v) self.db.profile.style= v end,
						validate = {"short", "full", "condensed"}
					},
					showbid = {
						type = 'toggle',
						name = L["Show Bid"], aliases='sb',
						desc = string.format(l["Toggles %s function."], L["Show Bid"]),
						get = function() return self.db.profile.showBid end,
						set = function(v) self.db.profile.showBid = v end
					},
  					bidstyle = {
						type = 'text',
						name = L["Bid Style"], aliases='bs',
						desc = L["Change bid style."],
						get = function() return self.db.profile.bidStyle end,
						set = function(v) self.db.profile.bidStyle= v end,
                        validate = {"text", "fade"}
					}
				}
			}
	end

	function mod:OnEnable()
		self:RegisterEvent("AH_LOADED")
	end

	function mod:OnDisable()
		if self:IsHooked("AuctionFrameBrowse_Update") then self:Unhook("AuctionFrameBrowse_Update") end
	end

	function mod:AH_LOADED()
		self:Hook("AuctionFrameBrowse_Update", true)
		self:UnregisterEvent("AH_LOADED")
	end
	
	function mod:AuctionFrameBrowse_Update()
		self.hooks["AuctionFrameBrowse_Update"]()

		local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
		local index, button, buttonName
        local sM, spMoney, bidText, bT

		for i=1, NUM_BROWSE_TO_DISPLAY do
			index = offset + i + (NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse.page)
			local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", offset + i)
			if name == nil then return end
			
			buttonName = "BrowseButton"..i
			local itemName = getglobal(buttonName.."Name")		
            local moneyFrame = getglobal(buttonName.."MoneyFrame")
            moneyFrame:SetAlpha(1)
            
			if buyoutPrice > 0 and count > 1 then
				local ep = floor(buyoutPrice/count)
				if self.db.profile.style == "short" then
					spMoney = abc:FormatMoneyShort(ep, true)
                    sM = strlen(abc:FormatMoneyShort(ep)) + 4
				elseif self.db.profile.style == "full" then
					spMoney = abc:FormatMoneyFull(ep, true)
                    sM = strlen(abc:FormatMoneyFull(ep)) + 4
				elseif self.db.profile.style == "condensed" then
					spMoney = abc:FormatMoneyCondensed(ep, true)
                    sM = strlen(abc:FormatMoneyCondensed(ep)) + 4
				end
            end    

			if bidAmount > 0 and self.db.profile.showBid then 
                if self.db.profile.bidStyle == "text" then
                    bidText = " - |cffffff00" .. L["Bid"] .. "|r"
                    bT = strlen(L["Bid"]) + 3
                elseif self.db.profile.bidStyle == "fade" then
                    moneyFrame:SetAlpha(.5)
                end
            end

            if spMoney then 
                spMoney = " ("..spMoney..") " 
            else 
                spMoney = "" 
                sM = 0 
            end
            if not bidText then 
                bidText = "" 
                bT = 0 
            end
            
            if (strlen(name)+sM+bT) > 40 then
                name = strsub(name,0,(strlen(name) - (sM+bT))).."..." 
            end

            itemName:SetText(name..spMoney..bidText)
            bidText, spMoney, sM, bT = nil, nil, nil, nil
        end 
    end
